# Ogre::GLHardwareBufferManager Class Reference

Implementation of HardwareBufferManager for OpenGL. More...

`#include <OgreGLHardwareBufferManager.h>`

Inheritance diagram for Ogre::GLHardwareBufferManager:

List of all members.

## Public Types

enum | BufferLicenseType { BLT_MANUAL_RELEASE, BLT_AUTOMATIC_RELEASE }

## Public Member Functions

| GLHardwareBufferManager ()
| ~GLHardwareBufferManager ()
HardwareVertexBufferSharedPtr | createVertexBuffer (size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
| Creates a vertex buffer.
HardwareIndexBufferSharedPtr | createIndexBuffer (HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
| Create a hardware vertex buffer.
VertexDeclaration * | createVertexDeclaration (void)
| Creates a vertex declaration, may be overridden by certain rendering APIs.
void | destroyVertexDeclaration (VertexDeclaration *decl)
| Destroys a vertex declaration, may be overridden by certain rendering APIs.
virtual VertexBufferBinding * | createVertexBufferBinding (void)
| Creates a new VertexBufferBinding.
virtual void | destroyVertexBufferBinding (VertexBufferBinding *binding)
| Destroys a VertexBufferBinding.
virtual void | registerVertexBufferSourceAndCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, const HardwareVertexBufferSharedPtr &copy)
| Registers a vertex buffer as a copy of another.
virtual HardwareVertexBufferSharedPtr | allocateVertexBufferCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, BufferLicenseType licenseType, HardwareBufferLicensee *licensee, bool copyData=false)
| Allocates a copy of a given vertex buffer.
virtual void | releaseVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Manually release a vertex buffer copy for others to subsequently use.
virtual void | _releaseBufferCopies (void)
| Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.
virtual void | _forceReleaseBufferCopies (const HardwareVertexBufferSharedPtr &sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
void | _forceReleaseBufferCopies (HardwareVertexBuffer *sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
void | _notifyVertexBufferDestroyed (HardwareVertexBuffer *buf)
| Notification that a hardware vertex buffer has been destroyed.
void | _notifyIndexBufferDestroyed (HardwareIndexBuffer *buf)
| Notification that a hardware index buffer has been destroyed.

## Static Public Member Functions

GLenum | getGLUsage (unsigned int usage)
| Utility function to get the correct GL usage based on HBU's.
GLenum | getGLType (unsigned int type)
| Utility function to get the correct GL type based on VET's.
HardwareBufferManager & | getSingleton (void)
| Override standard Singleton retrieval.
HardwareBufferManager * | getSingletonPtr (void)
| Override standard Singleton retrieval.

## Protected Types

typedef std::list< VertexDeclaration * > | VertexDeclarationList
typedef std::list< VertexBufferBinding * > | VertexBufferBindingList
typedef std::vector< HardwareVertexBufferSharedPtr > | FreeTemporaryVertexBufferList
| List of free temporary vertex buffers.
typedef std::map< HardwareVertexBuffer *, FreeTemporaryVertexBufferList * > | FreeTemporaryVertexBufferMap
| Map from original buffer to list of temporary buffers.
typedef std::vector< VertexBufferLicense > | TemporaryVertexBufferLicenseList
| List of currently licensed temp buffers.
typedef std::set< HardwareVertexBuffer * > | VertexBufferList
typedef std::set< HardwareIndexBuffer * > | IndexBufferList

## Protected Member Functions

virtual void | destroyAllDeclarations (void)
virtual void | destroyAllBindings (void)
HardwareVertexBufferSharedPtr | makeBufferCopy (const HardwareVertexBufferSharedPtr &source, HardwareBuffer::Usage usage, bool useShadowBuffer)
| Creates a new buffer as a copy of the source, does not copy data.

## Protected Attributes

VertexDeclarationList | mVertexDeclarations
VertexBufferBindingList | mVertexBufferBindings
FreeTemporaryVertexBufferMap | mFreeTempVertexBufferMap
| Map of current available temp buffers.
TemporaryVertexBufferLicenseList | mTempVertexBufferLicenses
| List of currently licensed temp buffers.
VertexBufferList | mVertexBuffers
IndexBufferList | mIndexBuffers

## Static Protected Attributes

HardwareBufferManager * | ms_Singleton

## Detailed Description

Implementation of HardwareBufferManager for OpenGL.

Definition at line 34 of file OgreGLHardwareBufferManager.h.

## Member Typedef Documentation

typedef std::vector<HardwareVertexBufferSharedPtr> Ogre::HardwareBufferManager::FreeTemporaryVertexBufferList `[protected, inherited]`

| List of free temporary vertex buffers. Definition at line 130 of file OgreHardwareBufferManager.h.

typedef std::map<HardwareVertexBuffer*, FreeTemporaryVertexBufferList*> Ogre::HardwareBufferManager::FreeTemporaryVertexBufferMap `[protected, inherited]`

| Map from original buffer to list of temporary buffers. Definition at line 132 of file OgreHardwareBufferManager.h.

typedef std::set<HardwareIndexBuffer*> Ogre::HardwareBufferManager::IndexBufferList `[protected, inherited]`

| Definition at line 141 of file OgreHardwareBufferManager.h.

typedef std::vector<VertexBufferLicense> Ogre::HardwareBufferManager::TemporaryVertexBufferLicenseList `[protected, inherited]`

| List of currently licensed temp buffers. Definition at line 136 of file OgreHardwareBufferManager.h.

typedef std::list<VertexBufferBinding*> Ogre::HardwareBufferManager::VertexBufferBindingList `[protected, inherited]`

| Definition at line 92 of file OgreHardwareBufferManager.h.

typedef std::set<HardwareVertexBuffer*> Ogre::HardwareBufferManager::VertexBufferList `[protected, inherited]`

| Definition at line 140 of file OgreHardwareBufferManager.h.

typedef std::list<VertexDeclaration*> Ogre::HardwareBufferManager::VertexDeclarationList `[protected, inherited]`

| Definition at line 91 of file OgreHardwareBufferManager.h.

## Member Enumeration Documentation

enum Ogre::HardwareBufferManager::BufferLicenseType `[inherited]`

Enumeration values:

  BLT_MANUAL_RELEASE | Licensee will only release buffer when it says so.
  BLT_AUTOMATIC_RELEASE | Licensee can have license revoked.

Definition at line 103 of file OgreHardwareBufferManager.h.

## Constructor & Destructor Documentation

Ogre::GLHardwareBufferManager::GLHardwareBufferManager | ( |  | ) |

Ogre::GLHardwareBufferManager::~GLHardwareBufferManager | ( |  | ) |

## Member Function Documentation

void Ogre::HardwareBufferManager::_forceReleaseBufferCopies | ( | HardwareVertexBuffer * | sourceBuffer | ) | `[inherited]`

Internal method that forces the release of copies of a given buffer.

Remarks:
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters:

  sourceBuffer | the source buffer as a pointer. Any buffer copies created from the source buffer are deleted.

virtual void Ogre::HardwareBufferManager::_forceReleaseBufferCopies | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer | ) | `[virtual, inherited]`

Internal method that forces the release of copies of a given buffer.

Remarks:
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters:

  sourceBuffer | the source buffer as a shared pointer. Any buffer copies created from the source buffer are deleted.

Definition at line 268 of file OgreHardwareBufferManager.h.

References Ogre::SharedPtr< HardwareVertexBuffer >::get().

void Ogre::HardwareBufferManager::_notifyIndexBufferDestroyed | ( | HardwareIndexBuffer * | buf | ) | `[inherited]`

| Notification that a hardware index buffer has been destroyed.

void Ogre::HardwareBufferManager::_notifyVertexBufferDestroyed | ( | HardwareVertexBuffer * | buf | ) | `[inherited]`

| Notification that a hardware vertex buffer has been destroyed.

virtual void Ogre::HardwareBufferManager::_releaseBufferCopies | ( | void |  | ) | `[virtual, inherited]`

| Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.

virtual HardwareVertexBufferSharedPtr Ogre::HardwareBufferManager::allocateVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | BufferLicenseType | licenseType,
|  | HardwareBufferLicensee * | licensee,
|  | bool | copyData = false
| ) | `[virtual, inherited]`

Allocates a copy of a given vertex buffer.

Remarks:
  This method allocates a temporary copy of an existing vertex buffer. This buffer is subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction.

Parameters:

  sourceBuffer | The source buffer to use as a copy
  licenseType | The type of license required on this buffer - automatic release causes this class to release licenses every frame so that they can be reallocated anew.
  licensee | Pointer back to the class requesting the copy, which must implement HardwareBufferLicense in order to be notified when the license expires.
  copyData | If true, the current data is copied as well as the structure of the buffer

HardwareIndexBufferSharedPtr Ogre::GLHardwareBufferManager::createIndexBuffer | ( | HardwareIndexBuffer::IndexType | itype,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = false
| ) | `[virtual]`

| Create a hardware vertex buffer. Implements Ogre::HardwareBufferManager.

HardwareVertexBufferSharedPtr Ogre::GLHardwareBufferManager::createVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVerts,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = false
| ) | `[virtual]`

| Creates a vertex buffer. Implements Ogre::HardwareBufferManager.

virtual VertexBufferBinding* Ogre::HardwareBufferManager::createVertexBufferBinding | ( | void |  | ) | `[virtual, inherited]`

| Creates a new VertexBufferBinding.

VertexDeclaration* Ogre::GLHardwareBufferManager::createVertexDeclaration | ( | void |  | ) | `[virtual]`

| Creates a vertex declaration, may be overridden by certain rendering APIs. Reimplemented from Ogre::HardwareBufferManager.

virtual void Ogre::HardwareBufferManager::destroyAllBindings | ( | void |  | ) | `[protected, virtual, inherited]`

virtual void Ogre::HardwareBufferManager::destroyAllDeclarations | ( | void |  | ) | `[protected, virtual, inherited]`

| Reimplemented in Ogre::D3D9HardwareBufferManager.

virtual void Ogre::HardwareBufferManager::destroyVertexBufferBinding | ( | VertexBufferBinding * | binding | ) | `[virtual, inherited]`

| Destroys a VertexBufferBinding.

void Ogre::GLHardwareBufferManager::destroyVertexDeclaration | ( | VertexDeclaration * | decl | ) | `[virtual]`

| Destroys a vertex declaration, may be overridden by certain rendering APIs. Reimplemented from Ogre::HardwareBufferManager.

GLenum Ogre::GLHardwareBufferManager::getGLType | ( | unsigned int | type | ) | `[static]`

| Utility function to get the correct GL type based on VET's.

GLenum Ogre::GLHardwareBufferManager::getGLUsage | ( | unsigned int | usage | ) | `[static]`

| Utility function to get the correct GL usage based on HBU's.

HardwareBufferManager& Ogre::HardwareBufferManager::getSingleton | ( | void |  | ) | `[static, inherited]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< HardwareBufferManager >.

HardwareBufferManager* Ogre::HardwareBufferManager::getSingletonPtr | ( | void |  | ) | `[static, inherited]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< HardwareBufferManager >.

HardwareVertexBufferSharedPtr Ogre::HardwareBufferManager::makeBufferCopy | ( | const HardwareVertexBufferSharedPtr & | source,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer
| ) | `[protected, inherited]`

| Creates a new buffer as a copy of the source, does not copy data.

virtual void Ogre::HardwareBufferManager::registerVertexBufferSourceAndCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | const HardwareVertexBufferSharedPtr & | copy
| ) | `[virtual, inherited]`

Registers a vertex buffer as a copy of another.

Remarks:
  This is useful for registering an existing buffer as a temporary buffer which can be allocated just like a copy.

virtual void Ogre::HardwareBufferManager::releaseVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) | `[virtual, inherited]`

Manually release a vertex buffer copy for others to subsequently use.

Remarks:
  Only required if the original call to allocateVertexBufferCopy included a licenseType of BLT_MANUAL_RELEASE.

Parameters:

  bufferCopy | The buffer copy. The caller is expected to delete or at least no longer use this reference, since another user may well begin to modify the contents of the buffer.

## Member Data Documentation

FreeTemporaryVertexBufferMap Ogre::HardwareBufferManager::mFreeTempVertexBufferMap `[protected, inherited]`

| Map of current available temp buffers. Definition at line 134 of file OgreHardwareBufferManager.h.

IndexBufferList Ogre::HardwareBufferManager::mIndexBuffers `[protected, inherited]`

| Definition at line 143 of file OgreHardwareBufferManager.h.

HardwareBufferManager * Ogre::Singleton< HardwareBufferManager >::ms_Singleton `[static, protected, inherited]`

| Definition at line 54 of file OgreSingleton.h.

TemporaryVertexBufferLicenseList Ogre::HardwareBufferManager::mTempVertexBufferLicenses `[protected, inherited]`

| List of currently licensed temp buffers. Definition at line 138 of file OgreHardwareBufferManager.h.

VertexBufferBindingList Ogre::HardwareBufferManager::mVertexBufferBindings `[protected, inherited]`

| Definition at line 95 of file OgreHardwareBufferManager.h.

VertexBufferList Ogre::HardwareBufferManager::mVertexBuffers `[protected, inherited]`

| Definition at line 142 of file OgreHardwareBufferManager.h.

VertexDeclarationList Ogre::HardwareBufferManager::mVertexDeclarations `[protected, inherited]`

| Definition at line 94 of file OgreHardwareBufferManager.h.

The documentation for this class was generated from the following file:

- OgreGLHardwareBufferManager.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Feb 12 13:10:09 2006